"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const dotenv = __importStar(require("dotenv"));
dotenv.config();
const anchor_1 = require("@project-serum/anchor");
const web3_js_1 = require("@solana/web3.js");
const client_1 = require("../src/client");
const constants_1 = require("../src/constants");
const fs_1 = __importDefault(require("fs"));
const CLUSTER = process.env.CLUSTER_OVERRIDE || 'mainnet-beta';
const CLUSTER_URL = process.env.CLUSTER_URL_OVERRIDE || process.env.MB_CLUSTER_URL;
const USER_KEYPAIR = process.env.USER_KEYPAIR_OVERRIDE || process.env.MB_PAYER_KEYPAIR;
const MANGO_ACCOUNT_PK = process.env.MANGO_ACCOUNT_PK || '';
const options = anchor_1.AnchorProvider.defaultOptions();
console.log('cluster', CLUSTER_URL);
const connection = new web3_js_1.Connection(CLUSTER_URL, options);
const user = web3_js_1.Keypair.fromSecretKey(Buffer.from(JSON.parse(process.env.KEYPAIR || fs_1.default.readFileSync(USER_KEYPAIR, 'utf-8'))));
const userWallet = new anchor_1.Wallet(user);
const userProvider = new anchor_1.AnchorProvider(connection, userWallet, options);
class TestGroupReload {
    group;
    mangoAccount;
    client;
    lastOraclePricesUpdateTs;
    constructor() {
        this.lastOraclePricesUpdateTs = 0;
    }
    async setup() {
        this.client = await client_1.MangoClient.connect(userProvider, CLUSTER, constants_1.MANGO_V4_ID[CLUSTER], {});
        // Load mango account
        this.mangoAccount = await this.client.getMangoAccount(new web3_js_1.PublicKey('HvJqTY8xgH2r2BuiPabgyf4bLLEaLewRGtRETvt7B1RC'));
        await this.mangoAccount.reload(this.client);
        // Load group
        this.group = await this.client.getGroup(this.mangoAccount.group);
        await this.group.reloadAll(this.client); // FIXME: need to refresh
    }
    async getPositionPerp() {
        if (Date.now() - this.lastOraclePricesUpdateTs > 10_000) {
            await this.mangoAccount.reload(this.client);
            console.time('reloading group');
            // await this.group.reloadPerpMarketOraclePrices(this.client);
            await this.group.reloadAll(this.client);
            this.lastOraclePricesUpdateTs = Date.now();
            console.timeEnd('reloading group');
            const nav = this.mangoAccount.getEquity(this.group).toNumber() / 1000000; // HERE
            console.log(`NAV=[${nav.toFixed(2)}]`);
        }
    }
    async run() {
        await this.setup();
        while (true) {
            await this.getPositionPerp();
        }
    }
}
const x = new TestGroupReload();
x.run();
